"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.executeTransformations = exports.jscodeshiftExecutable = exports.transformerDirectory = void 0;
var execa_1 = require("execa");
var path_1 = __importDefault(require("path"));
exports.transformerDirectory = path_1.default.join(__dirname, '../', 'transformers');
exports.jscodeshiftExecutable = require.resolve('jscodeshift/bin/jscodeshift.js');
function executeTransformation(_a) {
    var files = _a.files, flags = _a.flags, parser = _a.parser, transformer = _a.transformer, transformerArgs = _a.transformerArgs;
    var transformerPath = path_1.default.join(exports.transformerDirectory, "".concat(transformer, ".js"));
    var args = ['-t', transformerPath].concat(files);
    var dry = flags.dry;
    if (dry) {
        args.push('--dry');
    }
    args.push('--ignore-pattern', 'node_modules');
    args.push('--parser', parser);
    if (parser === 'tsx') {
        args.push('--extensions=tsx,ts');
    }
    else if (parser === 'ts') {
        args.push('--extensions=ts');
    }
    if (transformerArgs && transformerArgs.length > 0) {
        args = args.concat(transformerArgs);
    }
    console.log("Executing command: jscodeshift ".concat(args.join(' ')));
    var result = (0, execa_1.execaSync)('node', __spreadArray([exports.jscodeshiftExecutable], __read(args), false), {
        stdio: 'inherit',
        stripFinalNewline: false,
    });
    if (result.stderr) {
        throw result.stderr;
    }
}
function executeTransformations(_a) {
    var files = _a.files, flags = _a.flags, parser = _a.parser, transformers = _a.transformers, _b = _a.transformerArgs, transformerArgs = _b === void 0 ? [] : _b;
    transformers.forEach(function (t) {
        executeTransformation({
            files: files,
            flags: flags,
            transformer: t,
            parser: parser,
            transformerArgs: transformerArgs,
        });
    });
}
exports.executeTransformations = executeTransformations;
